<template>
  <div v-if="bannerForDisplay.length > 0" class="flex justify-center px-4">
    <div
      id="black-modern-mobile-banner-swiper"
      class="overflow-hidden max-w-[380px] h-[600px] pt-4 pb-20"
    >
      <swiper
        :space-between="30"
        :effect="'fade'"
        :navigation="{
          nextEl: '.banner-button-next',
          prevEl: '.banner-button-prev',
        }"
        :modules="modules"
        :speed="1000"
        :autoplay="{
          delay: 5000,
        }"
        loop
      >
        <swiper-slide v-for="banner in bannerForDisplay" :key="banner.HtmlId">
          <nuxt-link :to="banner.HyperLink" class="block w-full relative">
            <img
              v-lazy="banner.ImagePath"
              class="w-full h-[526px] rounded-lg"
              :alt="banner.Text"
            />
            <div class="absolute bottom-4">
              <div class="px-4 text-[#eef0f6]">
                <div class="slider-main__content"></div>
              </div>
            </div>
          </nuxt-link>
        </swiper-slide>
      </swiper>
      <div class="swiper-button-container">
        <div class="swiper-button banner-button-prev icon-button-prev">
          <font-awesome-icon icon="caret-left" />
        </div>
        <div class="swiper-button banner-button-next icon-button-next">
          <font-awesome-icon icon="caret-right" />
        </div>
      </div>
    </div>
  </div>
</template>
<script lang="ts">
import { Autoplay, EffectFade, Navigation } from "swiper";
import { computed, defineComponent, PropType, toRefs } from "vue";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import themePropertyHelper from "@/utils/themePropertyHelper";

export default defineComponent({
  name: "MBanner",
  props: {
    themeProperties: {
      type: Array as PropType<Array<IThemePropertiesFromApi>>,
      required: true,
    },
  },
  setup(props) {
    const { themeProperties } = toRefs(props);
    const bannerForDisplay = computed(
      (): Array<IThemePropertiesFromApi> =>
        themePropertyHelper.getMultipleThemesProperties(
          themeProperties.value,
          "lobby_banner_"
        )
    );
    return {
      bannerForDisplay,
      modules: [Navigation, EffectFade, Autoplay],
    };
  },
});
</script>
<style scoped>
.swiper-button-container {
  width: 100%;
  display: flex;
  justify-content: center;
  gap: 1.5rem;
  margin-bottom: 1rem;
}
.swiper-button-container .swiper-button {
  color: var(--accent-color);
  position: unset;
  cursor: pointer;
  font-size: 32px;
}
</style>
<style lang="scss">
#black-modern-mobile-banner-swiper {
  .swiper-button-next,
  .swiper-button-prev {
    bottom: 5%;
    top: unset;
    color: var(--primary-fallback);
  }
  .swiper-button-prev {
    left: 50%;
    margin-left: -30px;
  }
  .swiper-button-next {
    right: 50%;
    margin-right: -30px;
  }
}
</style>
